---
title: Update deployment gate
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Deployment Gates
---

# Update deployment gate{% #update-deployment-gate %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and may be subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                   |
| ----------------- | -------------------------------------------------------------- |
| ap1.datadoghq.com | PUT https://api.ap1.datadoghq.com/api/v2/deployment_gates/{id} |
| ap2.datadoghq.com | PUT https://api.ap2.datadoghq.com/api/v2/deployment_gates/{id} |
| app.datadoghq.eu  | PUT https://api.datadoghq.eu/api/v2/deployment_gates/{id}      |
| app.ddog-gov.com  | PUT https://api.ddog-gov.com/api/v2/deployment_gates/{id}      |
| us2.ddog-gov.com  | PUT https://api.us2.ddog-gov.com/api/v2/deployment_gates/{id}  |
| app.datadoghq.com | PUT https://api.datadoghq.com/api/v2/deployment_gates/{id}     |
| us3.datadoghq.com | PUT https://api.us3.datadoghq.com/api/v2/deployment_gates/{id} |
| us5.datadoghq.com | PUT https://api.us5.datadoghq.com/api/v2/deployment_gates/{id} |

### Overview

Endpoint to update a deployment gate. This endpoint requires the `deployment_gates_write` permission.

### Arguments

#### Path Parameters

| Name                 | Type   | Description                    |
| -------------------- | ------ | ------------------------------ |
| id [*required*] | string | The ID of the deployment gate. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                        | Type    | Description                                                           |
| ------------ | ---------------------------- | ------- | --------------------------------------------------------------------- |
|              | data [*required*]       | object  | Parameters for updating a deployment gate.                            |
| data         | attributes [*required*] | object  | Attributes for updating a deployment gate.                            |
| attributes   | dry_run [*required*]    | boolean | Whether to run in dry-run mode.                                       |
| data         | id [*required*]         | string  | Unique identifier of the deployment gate.                             |
| data         | type [*required*]       | enum    | Deployment gate resource type. Allowed enum values: `deployment_gate` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "dry_run": false
    },
    "id": "12345678-1234-1234-1234-123456789012",
    "type": "deployment_gate"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response for a deployment gate.

| Parent field | Field                        | Type      | Description                                                           |
| ------------ | ---------------------------- | --------- | --------------------------------------------------------------------- |
|              | data                         | object    | Data for a deployment gate.                                           |
| data         | attributes [*required*] | object    | Basic information about a deployment gate.                            |
| attributes   | created_at [*required*] | date-time | The timestamp when the deployment gate was created.                   |
| attributes   | created_by [*required*] | object    | Information about the user who created the deployment gate.           |
| created_by   | handle                       | string    | The handle of the user who created the deployment rule.               |
| created_by   | id [*required*]         | string    | The ID of the user who created the deployment rule.                   |
| created_by   | name                         | string    | The name of the user who created the deployment rule.                 |
| attributes   | dry_run [*required*]    | boolean   | Whether this gate is run in dry-run mode.                             |
| attributes   | env [*required*]        | string    | The environment of the deployment gate.                               |
| attributes   | identifier [*required*] | string    | The identifier of the deployment gate.                                |
| attributes   | service [*required*]    | string    | The service of the deployment gate.                                   |
| attributes   | updated_at                   | date-time | The timestamp when the deployment gate was last updated.              |
| attributes   | updated_by                   | object    | Information about the user who updated the deployment gate.           |
| updated_by   | handle                       | string    | The handle of the user who updated the deployment rule.               |
| updated_by   | id [*required*]         | string    | The ID of the user who updated the deployment rule.                   |
| updated_by   | name                         | string    | The name of the user who updated the deployment rule.                 |
| data         | id [*required*]         | string    | Unique identifier of the deployment gate.                             |
| data         | type [*required*]       | enum      | Deployment gate resource type. Allowed enum values: `deployment_gate` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2021-01-01T00:00:00Z",
      "created_by": {
        "handle": "test-user",
        "id": "1111-2222-3333-4444-555566667777",
        "name": "Test User"
      },
      "dry_run": false,
      "env": "production",
      "identifier": "pre",
      "service": "my-service",
      "updated_at": "2021-01-01T00:00:00Z",
      "updated_by": {
        "handle": "test-user",
        "id": "1111-2222-3333-4444-555566667777",
        "name": "Test User"
      }
    },
    "id": "1111-2222-3333-4444-555566667777",
    "type": "deployment_gate"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad request.
{% tab title="Model" %}
Bad request.

| Parent field | Field  | Type     | Description        |
| ------------ | ------ | -------- | ------------------ |
|              | errors | [object] | Structured errors. |
| errors       | detail | string   | Error message.     |
| errors       | status | string   | Error code.        |
| errors       | title  | string   | Error title.       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Malformed payload",
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Deployment gate not found.
{% tab title="Model" %}
Deployment gate not found.

| Parent field | Field  | Type     | Description        |
| ------------ | ------ | -------- | ------------------ |
|              | errors | [object] | Structured errors. |
| errors       | detail | string   | Error message.     |
| errors       | status | string   | Error code.        |
| errors       | title  | string   | Error title.       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Malformed payload",
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
Errors occurred.

| Parent field | Field  | Type     | Description        |
| ------------ | ------ | -------- | ------------------ |
|              | errors | [object] | Structured errors. |
| errors       | detail | string   | Error message.     |
| errors       | status | string   | Error code.        |
| errors       | title  | string   | Error title.       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Malformed payload",
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Path parameters export id="CHANGE_ME" \# Curl command curl -X PUT "https://api.datadoghq.com/api/v2/deployment_gates/${id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "dry_run": false
    },
    "id": "12345678-1234-1234-1234-123456789012",
    "type": "deployment_gate"
  }
}
EOF 
                        
##### 

```go
// Update deployment gate returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "deployment_gate" in the system
	DeploymentGateDataID := os.Getenv("DEPLOYMENT_GATE_DATA_ID")

	body := datadogV2.UpdateDeploymentGateParams{
		Data: datadogV2.UpdateDeploymentGateParamsData{
			Attributes: datadogV2.UpdateDeploymentGateParamsDataAttributes{
				DryRun: false,
			},
			Id:   "12345678-1234-1234-1234-123456789012",
			Type: datadogV2.DEPLOYMENTGATEDATATYPE_DEPLOYMENT_GATE,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.UpdateDeploymentGate", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewDeploymentGatesApi(apiClient)
	resp, r, err := api.UpdateDeploymentGate(ctx, DeploymentGateDataID, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `DeploymentGatesApi.UpdateDeploymentGate`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `DeploymentGatesApi.UpdateDeploymentGate`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Update deployment gate returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.DeploymentGatesApi;
import com.datadog.api.client.v2.model.DeploymentGateDataType;
import com.datadog.api.client.v2.model.DeploymentGateResponse;
import com.datadog.api.client.v2.model.UpdateDeploymentGateParams;
import com.datadog.api.client.v2.model.UpdateDeploymentGateParamsData;
import com.datadog.api.client.v2.model.UpdateDeploymentGateParamsDataAttributes;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.updateDeploymentGate", true);
    DeploymentGatesApi apiInstance = new DeploymentGatesApi(defaultClient);

    // there is a valid "deployment_gate" in the system
    String DEPLOYMENT_GATE_DATA_ID = System.getenv("DEPLOYMENT_GATE_DATA_ID");

    UpdateDeploymentGateParams body =
        new UpdateDeploymentGateParams()
            .data(
                new UpdateDeploymentGateParamsData()
                    .attributes(new UpdateDeploymentGateParamsDataAttributes().dryRun(false))
                    .id("12345678-1234-1234-1234-123456789012")
                    .type(DeploymentGateDataType.DEPLOYMENT_GATE));

    try {
      DeploymentGateResponse result =
          apiInstance.updateDeploymentGate(DEPLOYMENT_GATE_DATA_ID, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DeploymentGatesApi#updateDeploymentGate");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Update deployment gate returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.deployment_gates_api import DeploymentGatesApi
from datadog_api_client.v2.model.deployment_gate_data_type import DeploymentGateDataType
from datadog_api_client.v2.model.update_deployment_gate_params import UpdateDeploymentGateParams
from datadog_api_client.v2.model.update_deployment_gate_params_data import UpdateDeploymentGateParamsData
from datadog_api_client.v2.model.update_deployment_gate_params_data_attributes import (
    UpdateDeploymentGateParamsDataAttributes,
)

# there is a valid "deployment_gate" in the system
DEPLOYMENT_GATE_DATA_ID = environ["DEPLOYMENT_GATE_DATA_ID"]

body = UpdateDeploymentGateParams(
    data=UpdateDeploymentGateParamsData(
        attributes=UpdateDeploymentGateParamsDataAttributes(
            dry_run=False,
        ),
        id="12345678-1234-1234-1234-123456789012",
        type=DeploymentGateDataType.DEPLOYMENT_GATE,
    ),
)

configuration = Configuration()
configuration.unstable_operations["update_deployment_gate"] = True
with ApiClient(configuration) as api_client:
    api_instance = DeploymentGatesApi(api_client)
    response = api_instance.update_deployment_gate(id=DEPLOYMENT_GATE_DATA_ID, body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Update deployment gate returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.update_deployment_gate".to_sym] = true
end
api_instance = DatadogAPIClient::V2::DeploymentGatesAPI.new

# there is a valid "deployment_gate" in the system
DEPLOYMENT_GATE_DATA_ID = ENV["DEPLOYMENT_GATE_DATA_ID"]

body = DatadogAPIClient::V2::UpdateDeploymentGateParams.new({
  data: DatadogAPIClient::V2::UpdateDeploymentGateParamsData.new({
    attributes: DatadogAPIClient::V2::UpdateDeploymentGateParamsDataAttributes.new({
      dry_run: false,
    }),
    id: "12345678-1234-1234-1234-123456789012",
    type: DatadogAPIClient::V2::DeploymentGateDataType::DEPLOYMENT_GATE,
  }),
})
p api_instance.update_deployment_gate(DEPLOYMENT_GATE_DATA_ID, body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Update deployment gate returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_deployment_gates::DeploymentGatesAPI;
use datadog_api_client::datadogV2::model::DeploymentGateDataType;
use datadog_api_client::datadogV2::model::UpdateDeploymentGateParams;
use datadog_api_client::datadogV2::model::UpdateDeploymentGateParamsData;
use datadog_api_client::datadogV2::model::UpdateDeploymentGateParamsDataAttributes;

#[tokio::main]
async fn main() {
    // there is a valid "deployment_gate" in the system
    let deployment_gate_data_id = std::env::var("DEPLOYMENT_GATE_DATA_ID").unwrap();
    let body = UpdateDeploymentGateParams::new(UpdateDeploymentGateParamsData::new(
        UpdateDeploymentGateParamsDataAttributes::new(false),
        "12345678-1234-1234-1234-123456789012".to_string(),
        DeploymentGateDataType::DEPLOYMENT_GATE,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.UpdateDeploymentGate", true);
    let api = DeploymentGatesAPI::with_config(configuration);
    let resp = api
        .update_deployment_gate(deployment_gate_data_id.clone(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Update deployment gate returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.updateDeploymentGate"] = true;
const apiInstance = new v2.DeploymentGatesApi(configuration);

// there is a valid "deployment_gate" in the system
const DEPLOYMENT_GATE_DATA_ID = process.env.DEPLOYMENT_GATE_DATA_ID as string;

const params: v2.DeploymentGatesApiUpdateDeploymentGateRequest = {
  body: {
    data: {
      attributes: {
        dryRun: false,
      },
      id: "12345678-1234-1234-1234-123456789012",
      type: "deployment_gate",
    },
  },
  id: DEPLOYMENT_GATE_DATA_ID,
};

apiInstance
  .updateDeploymentGate(params)
  .then((data: v2.DeploymentGateResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
